/****************************************************************

  Traction Software, Inc. Confidential and Proprietary Information

  Copyright (c) 1996-2008 Traction Software, Inc.
  All rights reserved.

****************************************************************/

// PLEASE DO NOT DELETE THIS LINE -- make copyright depends on it.

function roundNumber(number,decimal_points) {
	if(!decimal_points) return Math.round(number);
	if(number == 0) {
		var decimals = "";
		for(var i=0;i<decimal_points;i++) decimals += "0";
		return "0."+decimals;
	}

	var exponent = Math.pow(10,decimal_points);
	var num = Math.round((number * exponent)).toString();
	return num.slice(0,-1*decimal_points) + "." + num.slice(-1*decimal_points)
}

function printNumber(number) {
  // Use if/then because switch/case doesn't seem to do auto conversions, doesn't match when it should [cjn 13.Jan.2009]
  if ( number == 0 || number == 1 || number == 2 || number == 3 || number == 4 || number == 5 ) {
    return number;
  } else {
    return roundNumber(number,1);
  }
}

(function() {

  var ColorAnim = YAHOO.util.ColorAnim,
    Easing = YAHOO.util.Easing,
    Ev = YAHOO.util.Event,
    Connect = YAHOO.util.Connect,
    JSON = YAHOO.lang.JSON,
    Dom = YAHOO.util.Dom,
    Ratings,
    RatingControl,
    PromoteControl,
    StarsControl;

  Ratings = {

    /**
     * An array of controls
     */
    controls: [],

    onDOMReady: function() {
      // don't let a failure here cause problems with page loading
      try {
	this.findAndCreate();

	// listen for DOMchanged so that we can add more renderings as necessary
	Events.attachCustom(Events.DOMchanged, this, this.findAndCreate);
      }
      catch (e) {}
    },

    findAndCreate: function() {
      try {
	// find all of the nodes we need to replace
	var nodes = document.getElementsByTagName("SUB"),
	i, sz, // for loop
	cur, // node
	type, options, fqid, format, // attributes
	vote_fqids = "", star_fqids = "", // form params
	found = {}; // map of arrays

	//       this.logger = new YAHOO.widget.LogReader();
	//       this.logger.show();

	if (nodes) {
	  for (i=0, sz=nodes.length; i<sz; i++) {
	    cur = nodes[i];
	    type = cur.getAttribute("type");
	    if (type === "rating") {
	      options = cur.getAttribute("options");
	      if (!options) continue;

	      options = JSON.parse(options);
	      if (!options) continue;

	      fqid = options.fqid;
	      if (!found[fqid]) {
		found[fqid] = [];
	      }
	      found[fqid].push({node:cur,options:options});

	      // make a comma separated list
	      format = options.format;
	      if (format == "1") {
		// stars
		if (star_fqids) {
		  star_fqids += ",";
		}
		star_fqids += fqid;
	      } else {
		// votes
		if (vote_fqids) {
		  vote_fqids += ",";
		}
		vote_fqids += fqid;
	      }
	    }
	  }

	  if (vote_fqids || star_fqids) {
	     Connect.initHeader("X-Traction-XMLHTTP", "true");
	     Connect.asyncRequest('POST', FORM_ACTION_READ_WRITE,
			          {
			           success: this.onAjaxSuccess,
				       failure: this.onAjaxFailure,
				       scope: this,
				       argument: { found: found }
			           },
			           "type=ratingsrpc&method=get&star_fqids="+star_fqids+"&vote_fqids="+vote_fqids);
	  }
	}


      }
      catch (e) {}
    },

    setRating: function(newrating, highlighter) {

      // glow if necessary
      if (highlighter) highlighter.glow();

      Connect.asyncRequest('POST', FORM_ACTION_READ_WRITE,
			   {
			   success: this.onAjaxSuccess,
			       failure: this.onAjaxFailure,
			       scope: this,
			       argument: { highlighter: highlighter }
			   },
			   "type=ratingsrpc&method=set&fqid="+newrating.fqid+"&vote="+newrating.vote+"&format="+newrating.format);
    },

    onAjaxSuccess: function(result) {

      try {
	var found = result.argument.found,
	highlighter = result.argument.highlighter,
	data = JSON.parse(result.responseText),
	i, sz, // for loop
	rating,
	nodes; // { fqid: LONG, vote: INT, score: INT, count: INT, format: [123], msg: STRING }

	for (i=0, sz=data.length; i<sz; i++) {
	  rating = data[i];
	  if (rating) {
	    // update existing
	    this.updateControls(rating);
	    // create new ones as necessary
	    this.createControls(rating, found);
	  }
	}

	// fade if necessary
	if (highlighter) highlighter.fade();
      }
      catch (e) {}
    },

    // check to see if there's a control for this already and update it
    updateControls: function(rating) {
      var i, sz, cur;
      for (i=0, sz=this.controls.length; i<sz; i++) {
	cur = this.controls[i];
	if (cur.fqid === rating.fqid) {
	  cur.update(rating);
	}
      }
    },

    // create a new control if necessary and insert it in all of the
    // places we have a found node
    createControls: function(rating, found) {
      if (found) {
	nodes = found[rating.fqid];
	if (nodes) {

	  var i,sz,control, format, node, options;
	  for (i=0, sz=nodes.length; i<sz; i++) {

	    node = nodes[i].node;
	    options = nodes[i].options;

	    // use the format from the node
// 	    format = rating.format;
	    format = options.format || 1;
	    format *= 1;

	    switch (format) {
	    case 3:
 	      control = new PromoteControl(format, rating.fqid, node, options, "rate rate-thumbs clear");
	      break;
	    case 2:
 	      control = new PromoteControl(format, rating.fqid, node, options, "rate rate-arrows clear");
	      break;
	    case 1:
 	      control = new StarsControl(format, rating.fqid, node, options);
	      break;
	    default:
	      control = null;
	      break;
	    }
	    if (control) {
	      control.update(rating);
	      this.controls.push(control);
	    }
	  }
	  // clear this out so that i don't try again
	  found[rating.fqid] = null;
	}
      }
    },

    onAjaxFailure: function(result) {

    },

    setRowDisplay: function(TR, classList, display) {
      try {
	for (var i=0, sz=classList.length; i<sz; i++) {
	  if (Dom.hasClass(TR, classList[i])) {
	    TR.style.display = display;
	  }
	}
      }
      catch (e) {}
    },

    toggleRowsByClass: function(A, show, hide) {

      try {

	var TR = A, sel = A, cur;

	// toggle selected style on the A tags
	while (A.previousSibling) {
	  A = A.previousSibling;
	}
	do {
	  if (A.tagName == "A") {
	    if (A == sel) {
	      Dom.addClass(A, "selected");
	    } else {
	      Dom.removeClass(A, "selected");
	    }
	  }
	}
	while (A = A.nextSibling);

	// go up to the TR
	while (TR && TR.tagName != "TR") {
	  TR = TR.parentNode;
	}

	if (TR) {

	  // go to the beginning of the TRs
	  TR = TR.parentNode.firstChild;

	  do {
	    // only do this for TRs
	    if (TR.tagName == "TR") {
	      this.setRowDisplay(TR, show, "");
	      this.setRowDisplay(TR, hide, "none");
	    }
	  }
	  while (TR = TR.nextSibling);

	}

      }
      catch (e) {}

      return false;
    }

  };
  YAHOO.traction.Ratings = Ratings;

  /**
   * Generic superclass for ratings controls
   */
  RatingControl = function(format, fqid, nodeToReplace, options, divClassName) {
    this.format = format;
    this.fqid = fqid;
    this.options = options;
    this.div = document.createElement("DIV");
    this.div.className = divClassName;

    if (options.readonly) {
      Dom.addClass(this.div, "readonly");
    }

    // grab the delimiter
    this.delim = options.delim || "/";

    this.build(this.div);

    nodeToReplace.parentNode.replaceChild(this.div, nodeToReplace);
  };
  RatingControl.prototype = {

    /**
     * @abstract
     */
    build: function(div) {},

    addFeedback: function(div) {

      if (!this.options.readonly) {
	this.messageDIV = document.createElement("DIV");
	this.messageDIV.className = "message";

	this.messageSPAN = document.createElement("SPAN");
	this.messageSPAN.className = "default";
	this.messageDIV.appendChild(this.messageSPAN);

	div.appendChild(this.messageDIV);
      }

      this.scoreDIV = document.createElement("DIV");
      this.scoreDIV.className = "score";
      div.appendChild(this.scoreDIV);
    },

    /**
     * @abstract
     */
    update: function(rating) {

      this.rating = rating;

      if (rating.msg) {
	// response to an update
	this.showMessage(rating.msg);

	// update the controls after a delay
	var me = this;
	setTimeout(function() {
		     if (rating.vote != 0) {
		       me.fade_done_vote();
		     } else {
		       me.fade_done_undo();
		     }
		   }, 2500);
      } else {
	this.showUndo();
      }
    },

    showUndo: function() {

      if (!this.options.readonly) {

	if (this.rating && this.rating.vote == 0) {
	  this.showMessage(this.options.unrated || "Rate this!");
	}
	else if (this.options.undo) {

	  if (!this.undoLink) {
	    this.undoLink = document.createElement("A");
	    this.undoLink.href = "javascript:void(0)";
	    this.undoLink.innerHTML = (this.options.reset || "Undo vote");
	    Ev.on(this.undoLink, "click", this.undo, this, true);
	    this.messageDIV.appendChild(this.undoLink);
	  }

	  this.messageSPAN.innerHTML = ""; // clear the message
	  this.undoLink.style.display = ""; // show the undo link

	}
	else {
	  this.showMessage(this.options.rated || "You Voted");
	}

      }
    },

    showMessage: function(msg) {
      if (!this.options.readonly) {
	if (this.undoLink) this.undoLink.style.display = "none";
	this.messageSPAN.innerHTML = msg;
      }
    },

    /**
     * Uses AJAX to update the Rating
     */
    vote: function(vote) {
      Ratings.setRating({fqid: this.fqid, vote: vote, format: this.format}, new YAHOO.traction.Highlighter(this.div));
    },

    fade_done_vote: function() {
      this.showUndo();
    },

    fade_done_undo: function() {
      this.showUndo();
    },

    undo: function() {
      this.vote(0);
    }

  };

  // ----------------------------------------------------------------------

  /**
   * Thumbs or Arrow
   *
   * thumbs.divClassName="rate rate-thumbs clear"
   * arrows.divClassName="rate rate-arrows clear"
   *
   */
  PromoteControl = function(format, fqid, nodeToReplace, options, divClassName) {
    PromoteControl.superclass.constructor.call(this, format, fqid, nodeToReplace, options, divClassName);
  };
  YAHOO.extend(PromoteControl, RatingControl);

  PromoteControl.prototype.build = function(container) {

    if (!this.options.readonly) {
      this.mainDIV = document.createElement("DIV");
      this.mainDIV.className = "rate-buttons-all";

      this.addLink(this.mainDIV, "+1", "rateup", this.up);

      if (this.options.bury) {
	this.addLink(this.mainDIV, "-1", "ratedown", this.down);
      }

      container.appendChild(this.mainDIV);
    }

    this.addFeedback(container);
  };

  PromoteControl.prototype.addLink = function(toDiv, text, className, onClick) {
    var div = document.createElement("DIV"), a = document.createElement("A");
    div.className = className;
    a.href = "javascript:void(0)";
    a.appendChild(document.createTextNode(" "));
//     a.appendChild(document.createTextNode(text));
    Ev.on(a, "click", onClick, this, true);
    div.appendChild(a);
    this.mainDIV.appendChild(div);
  };

  PromoteControl.prototype.up = function() {
    this.vote(1);
  };
  PromoteControl.prototype.down = function() {
    this.vote(-1);
  };

  /**
   * Modify the styles to represent the value
   */
  PromoteControl.prototype.update = function(rating) {

    // i'm not sure how we show the feedback for stars yet
    PromoteControl.superclass.update.call(this, rating);

    // highlight based on my vote
    switch (rating.vote*1) {
    case 1:
      Dom.addClass(this.mainDIV, "rated-up");
      Dom.removeClass(this.mainDIV, "rated-down");
      break;
    case 0:
      Dom.removeClass(this.mainDIV, "rated-up");
      Dom.removeClass(this.mainDIV, "rated-down");
      break;
    case -1:
      Dom.removeClass(this.mainDIV, "rated-up");
      Dom.addClass(this.mainDIV, "rated-down");
      break;
    }

    if (this.options.readonly) {
      this.scoreDIV.innerHTML = (this.options.score || "Score:")+" "+rating.score
    } else {
      this.scoreDIV.innerHTML = " "+this.delim+" "+(this.options.score || "Score:")+" "+rating.score;
    }
  };

  // ----------------------------------------------------------------------

  /**
   * Arrows
   */

  // ----------------------------------------------------------------------

  /**
   * 1-5 Stars
   */
  StarsControl = function(format, fqid, nodeToReplace, options) {
    StarsControl.superclass.constructor.call(this, format, fqid, nodeToReplace, options, "rate rate-stars clear");
  };
  YAHOO.extend(StarsControl, RatingControl);

  /**
   * Build the stars interface
   */
  StarsControl.prototype.build = function(div) {

    this.mainDIV = document.createElement("DIV");
    this.mainDIV.className = "rate-stars-all";

    var ul = document.createElement("DIV"),
    i, sz,
    li, a,
    numbers = [ "", "one", "two", "three", "four", "five" ],
    funcs = [ null, this.one, this.two, this.three, this.four, this.five ];

    for (i=1; i<6; i++) {
      li = document.createElement("DIV");
      li.className = "star";

      a = document.createElement("A");
      a.href = "javascript:void(0)";
      a.innerHTML = i;

      if (this.options.readonly) {
	a.disabled = true;
	a.style.cursor = "default";
      } else {
	Ev.on(a, "click", funcs[i], this, true);
	Ev.on(a, "mouseout", this.mouseout, this, true);
	Ev.on(a, "mouseover", this.mouseover, this, true);
      }

      li.appendChild(a);

      ul.appendChild(li);
    }
    this.mainDIV.appendChild(ul);
    div.appendChild(this.mainDIV);

    this.addFeedback(div);
  };

  // these two listeners make it so that you can change your vote
  StarsControl.prototype.mouseover = function(e) {

    var target = Ev.getTarget(e), prev = target.parentNode, next = target.parentNode, number = 0;

    this.clearStarClass("on");
    this.clearStarClass("vote");

    // style hover on this and previous
    do {
      Dom.addClass(prev, "hover");
      Dom.setStyle(prev.firstChild, "width", "100%");
      number++;
    }
    while (prev = prev.previousSibling);

    // clear hover on the rest
    while (next = next.nextSibling) {
      Dom.removeClass(next, "hover");
    }

    this.showMessage(this.options["word"+number] || this.defaultWord(number));
  };
  StarsControl.prototype.defaultWord = function(number) {
    switch (number) {
    case 1: return "Poor";
    case 2: return "Below Average";
    case 3: return "Average";
    case 4: return "Good";
    case 5: return "Excellent";
    }
    return "";
  };

  StarsControl.prototype.mouseout = function(e) {
    this.clearStarClass("hover");
    this.setScore();
    this.showUndo();
  };
  StarsControl.prototype.clearStarClass = function(className) {
    var children = this.mainDIV.firstChild.childNodes, i, sz;
    for (i=0, sz=children.length; i<sz; i++) {
      Dom.removeClass(children[i], className);
      children[i].firstChild.style.width = "16px";
    }
  };

  StarsControl.prototype.one = function() {
    this.vote(1);
  };
  StarsControl.prototype.two = function() {
    this.vote(2);
  };
  StarsControl.prototype.three = function() {
    this.vote(3);
  };
  StarsControl.prototype.four = function() {
    this.vote(4);
  };
  StarsControl.prototype.five = function() {
    this.vote(5);
  };

  StarsControl.prototype.setScore = function(newRating) {

    var rating, value, className, stardiv;

    // can be used to update or just show the existing one
    if (newRating) {
      rating = this.rating = newRating;
    } else {
      rating = this.rating;
    }

    if (rating) {

      if (rating.vote === 0) {
	value = rating.score;
	className = "on";
      } else {
	value = rating.vote;
	className = "vote";
      }

      // update the DIVs
      this.clearStarClass("on");
      this.clearStarClass("vote");

      stardiv = this.mainDIV.firstChild.firstChild;
      while (value > 0) {

	// set the class
	Dom.addClass(stardiv, className);

	// partial width where necessary
	if (value < 1) {
	  percent = value*100;
	  stardiv.firstChild.style.width = percent+"%";
	}

	// go to the next one
	stardiv = stardiv.nextSibling;
	value--;
      }

    }
  };

  /**
   * Modify the styles to represent the value
   */
  StarsControl.prototype.update = function(rating) {

    // superclass handles feedback
    StarsControl.superclass.update.call(this, rating);

    this.setScore(rating);

//    var output = " "+this.delim+" Avg: "+ printNumber(rating.score) + (rating.score == 1 ? " star" : " stars");
		var output = " "+this.delim + " " + i18n_ratings("average","Avg: ") + printNumber(rating.score) + (rating.score == 1 ? i18n_ratings("star"," star") : i18n_ratings("stars"," stars") );
    if (this.options.count) {
      // output += " "+this.delim+" "+rating.count+ (rating.count == 1 ? " rating" : " ratings");
      output += " "+this.delim + " " + (rating.count == 1 ? i18n_ratings("rating_before","") : i18n_ratings("ratings_before","")) + rating.count+ (rating.count == 1 ? i18n_ratings("rating_after"," rating") : i18n_ratings("ratings_after"," ratings"));
    }
    this.scoreDIV.innerHTML = output;
  };

  // ----------------------------------------------------------------------

  /**
   * Do a refresh when the DOM is ready
   */
  Ev.onDOMReady(Ratings.onDOMReady, Ratings, true);

 })();
